/**
 * Test case for define.
 * Runs with mocha.
 */

'use strict'

const define = require('../lib/define.js')
const assert = require('assert')
const co = require('co')
const fs = require('fs')

function noop () {
}

describe('define', () => {
  it('Define and run', () => co(function * () {
    let src = `${__dirname}/../doc/mocks/mockup-styles/foo.scss`
    let dest = `${__dirname}/../tmp/foo/bar/foo.css`
    let task = define(src, dest, {})
    assert.ok(task)

    let context = {
      verbose: false,
      logger: {
        info: noop,
        debug: noop,
        warn: noop,
        trace: noop
      }
    }
    yield task(context)
  }))

  it('Define and run with invalid src', () => co(function * () {
    let src = 'foo/bar/__not_exists__'
    let dest = `${__dirname}/../tmp/foo/bar/foo.css`
    let task = define(src, dest, {})
    assert.ok(task)

    let context = {
      verbose: false,
      logger: {
        info: noop,
        debug: noop,
        warn: noop,
        trace: noop
      }
    }
    yield task(context)

    assert.ok(
      fs.existsSync(dest)
    )
  }))
})

/* global describe, before, after, it */
